<template>
  <card>
    <b-row align-v="center">
      <b-tabs fill style="padding: 0 20px;">
        <b-tab active>
          <template v-slot:title v-if="!$isTemporal">
            <i class="ni ni-cloud-upload-96 mr-2"></i> Adjuntar Examenes
          </template>
          <template v-slot:title v-else>
            <i class="ni ni-cloud-upload-96 mr-2"></i> Examenes
          </template>

          <b-form @submit.prevent="uploadExam">
            <div class="mt-5" v-if="!$isTemporal">
              <b-row>
                <b-col lg="6">
                  <div>
                    <h4 style="color: grey">Especialidad:</h4>
                  </div>

                  <b-form-select v-model="upload.especialidad_id" class="mb-3">
                    <b-form-select-option :value="null"
                      >Seleccione la especialidad</b-form-select-option
                    >
                    <b-form-select-option v-for="esp in specializations" :key="esp._id" :value="esp._id"
                      >{{esp.nombre}}</b-form-select-option>
                  </b-form-select>
                </b-col>

                <b-col lg="6">
                  <div class="form-group">
                    <label class="form-control-label"
                      >Fecha</label
                    >
                    <input
                      class="form-control"
                      type="date"
                      v-model="upload.fecha"
                    />
                  </div>
                </b-col>

                <b-col lg="12">
                  <div>
                    <h4 style="color: grey">Adjuntar archivo</h4>
                  </div>
                  <b-form-file
                    v-model="upload.file"
                    :state="Boolean(upload.file)"
                    placeholder="Escoge un archivo o arrastralo hasta aquí"
                    drop-placeholder="Arrastra el archivo aquí"
                  ></b-form-file>
                </b-col>

                <b-col lg="12" class="mt-4">
                  <b-row align-h="end">
                    <base-button icon type="primary" nativeType="submit">
                      Guardar
                    </base-button>
                  </b-row>
                </b-col>
              </b-row>
            </div>

            <hr class="my-4" />
          </b-form>

          <!-- lista -->
          <b-row class="mb-3" v-for="exam in exams" :key="exam._id">
            <b-col class="ml-3 mr-3" lg="1">
              <div>
                <i class=" fas fa-3x fas fa-file-medical"></i>
              </div>
            </b-col>

            <b-col lg="5" class="">
              <div>
                <span style="color: grey; font-weight: bold" class="small">{{exam.file}}</span><br />
                <span class="small" style="color: grey; font-weight: 530">{{moment(exam.fecha).format("DD-MM-YYYY")}}</span>
              </div>
            </b-col>

            <b-col lg="2" class="mt-2">
              <b-button variant="primary" size="sm" @click="download(exam)">Descargar</b-button>
            </b-col>

            <b-col lg="1" class="mt-2" v-if="!$isTemporal">
              <b-button variant="danger" size="sm" @click="destroy(exam)">Eliminar</b-button>
            </b-col>

            <b-col lg="1" class="mb-5" v-if="!$isTemporal">
              <div class="ml-5 mr-1 mt-1 clickeable" @click="hide(exam)">
                <i
                  :class="'fas fa-2x ' + (exam.visibilidad ? 'fa-eye' : 'fa-eye-slash')"
                ></i>
              </div>
            </b-col>
          </b-row>
        </b-tab>
      </b-tabs>
    </b-row>
  </card>
</template>
<script>
import moment from 'moment';
import { userService } from "../../../services";
import { saveAs } from 'file-saver';

export default {
  data() {
    return {
      moment,
      selected: null,
      specializations: [],
      exams: [],
      upload: {
        file: null,
        fecha: moment().format("YYYY-MM-DD"),
        especialidad_id: null
      }
    };
  },
  mounted(){
    this.getSpecialitations();
    this.getExams();
  },
  methods: {
    hide(exam) {
      userService.changeVisibility_exam(exam._id).then(res => {
        
        this.getExams();
      })
    },
    download(exam) {
      userService.getFile(exam.file).then(res => res.blob()).then(blob => {
        saveAs(blob, exam.file);
      }).catch(() => {
        alert("Ocurrió un error al descargar")
      })
    },
    destroy(exam) {
      userService.deleteExam(exam._id).then(res => {
        alert("OK ELIMINADO");
        this.getExams();
      })
    },
    uploadExam(){
      if(!this.upload.especialidad_id){
        alert("Falta especialidad")
        return;
      }
      if(!this.upload.fecha){
        alert("Falta fecha")
        return;
      }
      //Formdata para subir archivo
      var formData = new FormData();
      formData.append("file", this.upload.file);
      formData.append("especialidad_id", this.upload.especialidad_id);
      formData.append("fecha", this.upload.fecha);

      userService.uploadExam(formData).then(res => {
        alert("OK SUBIDO")
        this.getExams();
        this.reset();
      }).catch(err => {
        alert("ERROR");
      })
    },
    getSpecialitations(){
      userService.getSpecializations().then(res => {
        this.specializations = res;
      })
    },
    getExams(){
      userService.getExams().then(res => {
        this.exams = res;
      })
    },
    reset(){
      this.upload = {
        file: null,
        fecha: moment().format("YYYY-MM-DD"),
        especialidad_id: null
      }
    }
  }
};
</script>
<style>
.clickeable {
  cursor: pointer;
}
</style>
